/*YAAME - AY whatever emulator
  Needs a LOT of tidying

  Known problems :

  Noise not emulated
  Envelopes not emulated (as I don't know how)
*/

#include <allegro.h>
#include <stdio.h>
#include "mz80.h"
#include "ay.h"

SAMPLE *ay[2][4];
unsigned char ram2[65536];
struct mz80context z802;
FILE *aylog;
char s[80];
unsigned char ayregs[2][16];
unsigned char aycurreg[2];
int aylength[2][4];
int c,d;

volatile void aycutoff()
{
      for (d=0;d<2;d++)
      {
            for (c=0;c<3;c++)
            {
                  if (aylength[d][c])
                  {
                        aylength[d][c]--;
                        if (!aylength[d][c])
                           adjust_sample(ay[d][c],0,127,1000,TRUE);
                  }
            }
      }
/*      adjust_sample(ay[0][0],0,127,1000,TRUE);
      adjust_sample(ay[0][1],0,127,1000,TRUE);
      adjust_sample(ay[0][2],0,127,1000,TRUE);
      adjust_sample(ay[1][0],0,127,1000,TRUE);
      adjust_sample(ay[1][1],0,127,1000,TRUE);
      adjust_sample(ay[1][2],0,127,1000,TRUE);*/
}

END_OF_FUNCTION(aycutoff);

static unsigned char aysample[32] =	/* a simple sine (sort of) wave */
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
};

void initay(int c)
{
      int a,b;
      memset(ayregs[0],0,16);
      memset(ayregs[1],0,16);
      aylog=fopen("ay.log","wt");
      ayporta1=ayportb1=ayporta2=ayportb2=NULL;
      install_sound(DIGI_AUTODETECT,MIDI_NONE,0);
      for (a=0;a<c;a++)
      {
            for (b=0;b<3;b++)
            {
                  ay[a][b]=create_sample(8,0,320,32);
                  if (ay[a][b])
                     memcpy(ay[a][b]->data,aysample,32);
                  play_sample(ay[a][b],0,127,100*100,TRUE);
            }
      }
      LOCK_VARIABLE(c);
      LOCK_VARIABLE(d);
      LOCK_FUNCTION(aycutoff);
      install_int_ex(aycutoff,BPS_TO_TIMER(60));
}

void dumpay()
{
      FILE *f=fopen("ay.dmp","wb");
      fwrite(ayregs[0],16,1,f);
      fwrite(ayregs[1],16,1,f);
      fclose(f);
      fclose(aylog);
}

UINT16 ayread1p(UINT16 addr, struct z80PortRead *m)
{
      sprintf(s,"Reading AY 1 reg %02X data %02X\n",aycurreg[0],ayregs[0][aycurreg[0]]);
      fputs(s,aylog);
      if ((aycurreg[0]==14) && (ayporta1!=NULL))
         return ayporta1();
      if ((aycurreg[0]==15) && (ayportb1!=NULL))
         return ayportb1();
      return ayregs[0][aycurreg[0]];
}

UINT16 ayread2p(UINT16 addr, struct z80PortRead *m)
{
      UINT8 ret;
//      sprintf(s,"Reading AY 2 reg %02X data %02X\n",aycurreg[1],ayregs[1][aycurreg[0]]);
//      fputs(s,aylog);
      if ((aycurreg[1]==14) && (ayporta2!=NULL))
         return ayporta2();
      if ((aycurreg[1]==15) && (ayportb2!=NULL))
      {
            ret=ayportb2();
//            mz80GetContext(&z802);
//            sprintf(s,"AY 2 Port B %02X %02X %02X\n",ret,ram2[z802.z80sp+1],ram2[z802.z80sp]);
//            fputs(s,aylog);
            return ret;
      }
      return ayregs[1][aycurreg[1]];
}

void aywrite1p(UINT16 addr, UINT8 data, struct z80PortWrite *m)
{
      int freq;
      sprintf(s,"Writing AY 1 reg %02X data %02X\n",aycurreg[0],data);
      fputs(s,aylog);
      ayregs[0][aycurreg[0]]=data;
      switch (aycurreg[0])
      {
            case 0:
            case 1:
            freq=ayregs[0][0]|((ayregs[0][1]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[0][0],255,127,((ayclock1>>1)/freq)*100,TRUE);
                  aylength[0][0]=4;
            }
            else
               adjust_sample(ay[0][0],0,127,1000,TRUE);
            break;
            case 2:
            case 3:
            freq=ayregs[0][2]|((ayregs[0][3]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[0][1],255,127,((ayclock1>>1)/freq)*100,TRUE);
                  aylength[0][1]=4;
            }
            else
               adjust_sample(ay[0][1],0,127,1000,TRUE);
            break;
            case 4:
            case 5:
            freq=ayregs[0][4]|((ayregs[0][5]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[0][2],255,127,((ayclock1>>1)/freq)*100,TRUE);
                  aylength[0][2]=4;
            }
            else
               adjust_sample(ay[0][2],0,127,1000,TRUE);
            break;
      }
}

void aywritectrl1p(UINT16 addr, UINT8 data, struct z80PortWrite *m)
{
      sprintf(s,"Writing AY 1 ctrl to %02X\n",data);
      fputs(s,aylog);
      aycurreg[0]=data;
}

void aywrite2p(UINT16 addr, UINT8 data, struct z80PortWrite *m)
{
      int freq;
      sprintf(s,"Writing AY 2 reg %02X data %02X\n",aycurreg[1],data);
      fputs(s,aylog);
      ayregs[1][aycurreg[1]]=data;
      switch (aycurreg[1])
      {
            case 0:
            case 1:
            freq=ayregs[1][0]|((ayregs[1][1]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[1][0],255,127,((ayclock2>>1)/freq)*100,TRUE);
                  aylength[1][0]=4;
            }
            else
               adjust_sample(ay[1][0],0,127,1000,TRUE);
            break;
            case 2:
            case 3:
            freq=ayregs[1][2]|((ayregs[1][3]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[1][1],255,127,((ayclock2>>1)/freq)*100,TRUE);
                  aylength[1][1]=4;
            }
            else
               adjust_sample(ay[1][1],0,127,1000,TRUE);
            break;
            case 4:
            case 5:
            freq=ayregs[1][4]|((ayregs[1][5]&15)<<8);
            freq<<=4;
            if (freq)
            {
                  adjust_sample(ay[1][2],255,127,((ayclock2>>1)/freq)*100,TRUE);
                  aylength[1][2]=4;
            }
            else
               adjust_sample(ay[1][2],0,127,1000,TRUE);
            break;
      }
}

void aywritectrl2p(UINT16 addr, UINT8 data, struct z80PortWrite *m)
{
//      sprintf(s,"Writing AY 2 ctrl to %02X\n",data);
  //    fputs(s,aylog);
      aycurreg[1]=data;
}

void aywriteporta2p(UINT16 addr, UINT8 data, struct z80PortWrite *m)
{
      ayregs[1][14]=data;
}

UINT8 ayread1(UINT32 addr, struct MemoryReadByte *m)
{
      if ((aycurreg[0]==14) && (ayporta1!=NULL))
         return ayporta1();
      if ((aycurreg[0]==15) && (ayportb1!=NULL))
         return ayportb1();
      return ayregs[0][aycurreg[0]];
}

UINT8 ayread2(UINT32 addr, struct MemoryReadByte *m)
{
      if ((aycurreg[1]==14) && (ayporta2!=NULL))
         return ayporta2();
      if ((aycurreg[1]==15) && (ayportb2!=NULL))
         return ayportb2();
      return ayregs[1][aycurreg[1]];
}

void aywrite1(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      ayregs[0][aycurreg[0]]=data;
}

void aywritectrl1(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      aycurreg[0]=data;
}

void aywrite2(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      ayregs[1][aycurreg[1]]=data;
}

void aywritectrl2(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      aycurreg[1]=data;
}

void aywriteporta1(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      ayregs[0][14]=data;
}

void aywriteporta2(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      sprintf(s,"AY 2 port A now %02X\n",data);
      fputs(s,aylog);
      ayregs[1][14]=data;
      sprintf(s,"%02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X\n",ayregs[0][0],ayregs[0][1],ayregs[0][2],ayregs[0][3],ayregs[0][4],ayregs[0][5],ayregs[0][6],ayregs[0][7],ayregs[0][8],ayregs[0][9],ayregs[0][10],ayregs[0][11],ayregs[0][12],ayregs[0][13],ayregs[0][14],ayregs[0][15]);
      fputs(s,aylog);
      sprintf(s,"%02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X\n",ayregs[1][0],ayregs[1][1],ayregs[1][2],ayregs[1][3],ayregs[1][4],ayregs[1][5],ayregs[1][6],ayregs[1][7],ayregs[1][8],ayregs[1][9],ayregs[1][10],ayregs[1][11],ayregs[1][12],ayregs[1][13],ayregs[1][14],ayregs[1][15]);
      fputs(s,aylog);
}

void aywriteportb1(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      ayregs[0][15]=data;
}

void aywriteportb2(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      ayregs[1][15]=data;
}
