/*YAAME - SN76489 emulation
  Needs a bit of tidying up
*/

#include <stdio.h>
#include "mz80.h"
#include <allegro.h>
#include "sn.h"

FILE *snlog;
char s[80];
unsigned char snfreqhi[4][4],snfreqlo[4][4];
unsigned char snvol[4][4];
unsigned char snnoise[4];
int curfreq[4][4];
int lasttone[4];

SAMPLE *snsample[4][4];

int snclock1,snclock2,snclock3,snclock4;

static unsigned char snsamples[32] =	/* a simple sine (sort of) wave */
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
};

static unsigned char snperiodic[32768] =
{
      0x7F,0x7F,0x7F,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static unsigned char snnoises[32768];

void sninit(int c)
{
      int a,b;
      reserve_voices(c*4,0);
      install_sound(DIGI_AUTODETECT,MIDI_NONE,0);
      for (a=0;a<32768;a++)
          snnoises[a]=random()&255;
      for (a=64;a<32768;a++)
          snperiodic[a]=snperiodic[a&63];
      for (a=0;a<c;a++)
      {
            for (b=1;b<4;b++)
            {
                  snsample[a][b]=create_sample(8,0,320,32);
                  if (snsample[a][b])
                     memcpy(snsample[a][b]->data,snsamples,32);
                  play_sample(snsample[a][b],0,127,100*100,TRUE);
            }
//            if (!a)
//            {
                  snsample[a][0]=create_sample(8,0,320,32768);
                  if (snsample[a][0])
                     memcpy(snsample[a][0]->data,snperiodic,32768);
                  play_sample(snsample[a][0],0,127,100*100,TRUE);
//            }
      }
      snlog=fopen("sn.log","wt");
      snclock1=snclock2=snclock3=snclock4=4000000>>5;
}

void snwrite1(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      int freq;
      sprintf(s,"SN #1 write %02X\n",data);
      fputs(s,snlog);
      if (data&0x80)
      {
            switch (data&0x70)
            {
                  case 0:
                  snfreqlo[0][3]=data&0xF;
                  lasttone[0]=3;
                  break;
                  case 0x10:
                  data&=0xF;
                  snvol[0][3]=0xF-data;
                  sprintf(s,"vol 3 now %01X\n",snvol[0][3]);
                  fputs(s,snlog);
                  adjust_sample(snsample[0][3],snvol[0][3]<<4,127,curfreq[0][3]*100,TRUE);
                  break;
                  case 0x20:
                  snfreqlo[0][2]=data&0xF;
                  lasttone[0]=2;
                  break;
                  case 0x30:
                  data&=0xF;
                  snvol[0][2]=0xF-data;
                  sprintf(s,"vol 2 now %01X\n",snvol[0][2]);
                  fputs(s,snlog);
                  adjust_sample(snsample[0][2],snvol[0][2]<<4,127,curfreq[0][2]*100,TRUE);
                  break;
                  case 0x40:
                  snfreqlo[0][1]=data&0xF;
                  lasttone[0]=1;
                  break;
                  case 0x50:
                  data&=0xF;
                  snvol[0][1]=0xF-data;
                  sprintf(s,"vol 1 now %01X\n",snvol[0][1]);
                  fputs(s,snlog);
                  adjust_sample(snsample[0][1],snvol[0][1]<<4,127,curfreq[0][1]*100,TRUE);
                  break;
                  case 0x60:
                  sprintf(s,"noise now %01X\n",data&3);
                  fputs(s,snlog);
                  snnoise[0]=data&0xF;
                  if ((data&3)==3)
                     curfreq[0][0]=curfreq[0][1]>>3;
                  else
                  {
                        switch (data&3)
                        {
                              case 0:
                              curfreq[0][0]=100;
                              break;
                              case 1:
                              curfreq[0][0]=200;
                              break;
                              case 2:
                              curfreq[0][0]=400;
                              break;
                        }
                  }
                  if (!(data&4))
                  {
                        memcpy(snsample[0][0]->data,snperiodic,32768);
//                        snsample[0][0]->len=32;
                  }
                  else
                  {
                        memcpy(snsample[0][0]->data,snnoises,32768);
//                        snsample[0][0]->len=32768;
                  }
                  adjust_sample(snsample[0][0],snvol[0][0]<<4,127,curfreq[0][0]*100,TRUE);
                  break;
                  case 0x70:
                  data&=0xF;
                  snvol[0][0]=0xF-data;
                  sprintf(s,"vol 0 now %01X\n",snvol[0][0]);
                  fputs(s,snlog);
                  adjust_sample(snsample[0][0],snvol[0][0]<<4,127,curfreq[0][0]*100,TRUE);
                  break;
            }
      }
      else
      {
            snfreqhi[0][lasttone[0]]=data&0x3F;
            freq=snfreqlo[0][lasttone[0]]|(snfreqhi[0][lasttone[0]]<<4);
            if (freq)
            {
                  curfreq[0][lasttone[0]]=(snclock1/freq);
                  if ((snnoise[0]&3)==3&&lasttone[0]==1)
                  {
                        curfreq[0][0]=curfreq[0][1]>>3;
                        adjust_sample(snsample[0][0],snvol[0][0]<<4,127,curfreq[0][0]*100,TRUE);
                  }
                  adjust_sample(snsample[0][lasttone[0]],snvol[0][lasttone[0]]<<4,127,(snclock2/freq)*100,TRUE);
            }
            else
            {
                  curfreq[0][lasttone[0]]=0;
                  adjust_sample(snsample[0][lasttone[0]],0,127,0,TRUE);
            }
      }
}

void snwrite2(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      int freq;
      sprintf(s,"SN #2 write %02X\n",data);
      fputs(s,snlog);
      if (data&0x80)
      {
            switch (data&0x70)
            {
                  case 0:
                  snfreqlo[1][3]=data&0xF;
                  lasttone[1]=3;
                  break;
                  case 0x10:
                  data&=0xF;
                  snvol[1][3]=0xF-data;
                  sprintf(s,"vol 3 now %01X\n",snvol[1][3]);
                  fputs(s,snlog);
                  adjust_sample(snsample[1][3],snvol[1][3]<<4,127,curfreq[1][3]*100,TRUE);
                  break;
                  case 0x20:
                  snfreqlo[1][2]=data&0xF;
                  lasttone[1]=2;
                  break;
                  case 0x30:
                  data&=0xF;
                  snvol[1][2]=0xF-data;
                  sprintf(s,"vol 2 now %01X\n",snvol[1][2]);
                  fputs(s,snlog);
                  adjust_sample(snsample[1][2],snvol[1][2]<<4,127,curfreq[1][2]*100,TRUE);
                  break;
                  case 0x40:
                  snfreqlo[1][1]=data&0xF;
                  lasttone[1]=1;
                  break;
                  case 0x50:
                  data&=0xF;
                  snvol[1][1]=0xF-data;
                  sprintf(s,"vol 1 now %01X\n",snvol[1][1]);
                  fputs(s,snlog);
                  adjust_sample(snsample[1][1],snvol[1][1]<<4,127,curfreq[1][1]*100,TRUE);
                  break;
                  case 0x60:
                  sprintf(s,"noise now %01X\n",data&3);
                  fputs(s,snlog);
                  snnoise[1]=data&0xF;
                  if ((data&3)==3)
                     curfreq[1][0]=curfreq[1][1]>>3;
                  else
                  {
                        switch (data&3)
                        {
                              case 0:
                              curfreq[1][0]=100;
                              break;
                              case 1:
                              curfreq[1][0]=200;
                              break;
                              case 2:
                              curfreq[1][0]=400;
                              break;
                        }
                  }
                  if (!(data&4))
                  {
                        memcpy(snsample[1][0]->data,snperiodic,32768);
//                        snsample[1][0]->len=32;
                  }
                  else
                  {
                        memcpy(snsample[1][0]->data,snnoises,32768);
//                        snsample[1][0]->len=32768;
                  }
                  adjust_sample(snsample[1][0],snvol[1][0]<<4,127,curfreq[1][0]*100,TRUE);
                  break;
                  case 0x70:
                  data&=0xF;
                  snvol[1][0]=0xF-data;
                  sprintf(s,"vol 0 now %01X\n",snvol[1][0]);
                  fputs(s,snlog);
                  adjust_sample(snsample[1][0],snvol[1][0]<<4,127,curfreq[1][0]*100,TRUE);
                  break;
            }
      }
      else
      {
            snfreqhi[1][lasttone[1]]=data&0x3F;
            freq=snfreqlo[1][lasttone[1]]|(snfreqhi[1][lasttone[1]]<<4);
            if (freq)
            {
                  curfreq[1][lasttone[1]]=(snclock2/freq);
                  if ((snnoise[1]&3)==3&&lasttone[1]==1)
                  {
                        curfreq[1][0]=curfreq[1][1]>>3;
                        adjust_sample(snsample[1][0],snvol[1][0]<<4,127,curfreq[1][0]*100,TRUE);
                  }
                  adjust_sample(snsample[1][lasttone[1]],snvol[1][lasttone[1]]<<4,127,(snclock2/freq)*100,TRUE);
            }
            else
            {
                  curfreq[1][lasttone[1]]=0;
                  adjust_sample(snsample[1][lasttone[1]],0,127,0,TRUE);
            }
      }
}

void snwrite3(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      int freq;
      sprintf(s,"SN #3 write %02X\n",data);
      fputs(s,snlog);
      if (data&0x80)
      {
            switch (data&0x70)
            {
                  case 0:
                  snfreqlo[2][3]=data&0xF;
                  lasttone[2]=3;
                  break;
                  case 0x10:
                  data&=0xF;
                  snvol[2][3]=0xF-data;
                  sprintf(s,"vol 3 now %01X\n",snvol[2][3]);
                  fputs(s,snlog);
                  adjust_sample(snsample[2][3],snvol[2][3]<<4,127,curfreq[2][3]*100,TRUE);
                  break;
                  case 0x20:
                  snfreqlo[2][2]=data&0xF;
                  lasttone[2]=2;
                  break;
                  case 0x30:
                  data&=0xF;
                  snvol[2][2]=0xF-data;
                  sprintf(s,"vol 2 now %01X\n",snvol[2][2]);
                  fputs(s,snlog);
                  adjust_sample(snsample[2][2],snvol[2][2]<<4,127,curfreq[2][2]*100,TRUE);
                  break;
                  case 0x40:
                  snfreqlo[2][1]=data&0xF;
                  lasttone[2]=1;
                  break;
                  case 0x50:
                  data&=0xF;
                  snvol[2][1]=0xF-data;
                  sprintf(s,"vol 1 now %01X\n",snvol[2][1]);
                  fputs(s,snlog);
                  adjust_sample(snsample[2][1],snvol[2][1]<<4,127,curfreq[2][1]*100,TRUE);
                  break;
                  case 0x60:
                  sprintf(s,"noise now %01X\n",data&3);
                  fputs(s,snlog);
                  snnoise[2]=data&0xF;
                  if ((data&3)==3)
                     curfreq[2][0]=curfreq[2][1]>>3;
                  else
                  {
                        switch (data&3)
                        {
                              case 0:
                              curfreq[2][0]=100;
                              break;
                              case 1:
                              curfreq[2][0]=200;
                              break;
                              case 2:
                              curfreq[2][0]=400;
                              break;
                        }
                  }
                  if (!(data&4))
                  {
                        memcpy(snsample[2][0]->data,snperiodic,32768);
//                        snsample[2][0]->len=32;
                  }
                  else
                  {
                        memcpy(snsample[2][0]->data,snnoises,32768);
//                        snsample[2][0]->len=32768;
                  }
                  adjust_sample(snsample[2][0],snvol[2][0]<<4,127,curfreq[2][0]*100,TRUE);
                  break;
                  case 0x70:
                  data&=0xF;
                  snvol[2][0]=0xF-data;
                  sprintf(s,"vol 0 now %01X\n",snvol[2][0]);
                  fputs(s,snlog);
                  adjust_sample(snsample[2][0],snvol[2][0]<<4,127,curfreq[2][0]*100,TRUE);
                  break;
            }
      }
      else
      {
            snfreqhi[2][lasttone[2]]=data&0x3F;
            freq=snfreqlo[2][lasttone[2]]|(snfreqhi[2][lasttone[2]]<<4);
            if (freq)
            {
                  curfreq[2][lasttone[2]]=(snclock3/freq);
                  if ((snnoise[2]&3)==3&&lasttone[2]==1)
                  {
                        curfreq[2][0]=curfreq[2][1]>>3;
                        adjust_sample(snsample[2][0],snvol[2][0]<<4,127,curfreq[2][0]*100,TRUE);
                  }
                  adjust_sample(snsample[2][lasttone[2]],snvol[2][lasttone[2]]<<4,127,(snclock3/freq)*100,TRUE);
            }
            else
            {
                  curfreq[2][lasttone[2]]=0;
                  adjust_sample(snsample[2][lasttone[2]],0,127,0,TRUE);
            }
      }
}

void snwrite4(UINT32 addr, UINT8 data, struct MemoryWriteByte *m)
{
      int freq;
      sprintf(s,"SN #2 write %02X\n",data);
      fputs(s,snlog);
      if (data&0x80)
      {
            switch (data&0x70)
            {
                  case 0:
                  snfreqlo[3][3]=data&0xF;
                  lasttone[3]=3;
                  break;
                  case 0x10:
                  data&=0xF;
                  snvol[3][3]=0xF-data;
                  sprintf(s,"vol 3 now %01X\n",snvol[3][3]);
                  fputs(s,snlog);
                  adjust_sample(snsample[3][3],snvol[3][3]<<4,127,curfreq[3][3]*100,TRUE);
                  break;
                  case 0x20:
                  snfreqlo[3][2]=data&0xF;
                  lasttone[3]=2;
                  break;
                  case 0x30:
                  data&=0xF;
                  snvol[3][2]=0xF-data;
                  sprintf(s,"vol 2 now %01X\n",snvol[3][2]);
                  fputs(s,snlog);
                  adjust_sample(snsample[3][2],snvol[3][2]<<4,127,curfreq[3][2]*100,TRUE);
                  break;
                  case 0x40:
                  snfreqlo[3][1]=data&0xF;
                  lasttone[3]=1;
                  break;
                  case 0x50:
                  data&=0xF;
                  snvol[3][1]=0xF-data;
                  sprintf(s,"vol 1 now %01X\n",snvol[3][1]);
                  fputs(s,snlog);
                  adjust_sample(snsample[3][1],snvol[3][1]<<4,127,curfreq[3][1]*100,TRUE);
                  break;
                  case 0x60:
                  sprintf(s,"noise now %01X\n",data&3);
                  fputs(s,snlog);
                  snnoise[3]=data&0xF;
                  if ((data&3)==3)
                     curfreq[3][0]=curfreq[3][1]>>3;
                  else
                  {
                        switch (data&3)
                        {
                              case 0:
                              curfreq[3][0]=100;
                              break;
                              case 1:
                              curfreq[3][0]=200;
                              break;
                              case 2:
                              curfreq[3][0]=400;
                              break;
                        }
                  }
                  if (!(data&4))
                  {
                        memcpy(snsample[3][0]->data,snperiodic,32768);
//                        snsample[3][0]->len=32;
                  }
                  else
                  {
                        memcpy(snsample[3][0]->data,snnoises,32768);
//                        snsample[3][0]->len=32768;
                  }
                  adjust_sample(snsample[3][0],snvol[3][0]<<4,127,curfreq[3][0]*100,TRUE);
                  break;
                  case 0x70:
                  data&=0xF;
                  snvol[3][0]=0xF-data;
                  sprintf(s,"vol 0 now %01X\n",snvol[3][0]);
                  fputs(s,snlog);
                  adjust_sample(snsample[3][0],snvol[3][0]<<4,127,curfreq[3][0]*100,TRUE);
                  break;
            }
      }
      else
      {
            snfreqhi[3][lasttone[3]]=data&0x3F;
            freq=snfreqlo[3][lasttone[3]]|(snfreqhi[3][lasttone[3]]<<4);
            if (freq)
            {
                  curfreq[3][lasttone[3]]=(snclock2/freq);
                  if ((snnoise[3]&3)==3&&lasttone[3]==1)
                  {
                        curfreq[3][0]=curfreq[3][1]>>3;
                        adjust_sample(snsample[3][0],snvol[3][0]<<4,127,curfreq[3][0]*100,TRUE);
                  }
                  adjust_sample(snsample[3][lasttone[3]],snvol[3][lasttone[3]]<<4,127,(snclock2/freq)*100,TRUE);
            }
            else
            {
                  curfreq[3][lasttone[3]]=0;
                  adjust_sample(snsample[3][lasttone[3]],0,127,0,TRUE);
            }
      }
}
