/*YAAME - Menu*/

#include "gfx.h"
#include <stdio.h>

int phoenixinit();
void phoenixrun();
int pleiadsinit();
int konginit();
int radarscopeinit();
void kongrun();
int siinit();
int si2init();
int eiinit();
void sirun();
int galaxianinit();
int warofbuginit();
int pacmanblinit();
void galaxianrun();
int anteaterinit();
void anteaterrun();
int amidarinit();
int turtlesinit();
void amidarrun();
int bombjackinit();
void bombjackrun();
int mrdoinit();
void mrdorun();
int popeyeinit();
void popeyerun();
int nibblerinit();
void nibblerrun();
int scobrainit();
int dorunruninit();
int docastleinit();
void dorunrunrun();

int game;

PALETTE yaamepal;

typedef struct YAAMEGAME
{
        unsigned char name[40];
        int (*init)();
        void (*run)();
} YAAMEGAME;

YAAMEGAME games[]=
{
        {"Phoenix",phoenixinit,phoenixrun},
        {"Pleiads",pleiadsinit,phoenixrun},
        {"Donkey Kong",konginit,kongrun},
        {"Radar Scope",radarscopeinit,kongrun},
        {"Space Invaders",siinit,sirun},
        {"Space Invaders Part II",si2init,sirun},
        {"Earth Invasion",eiinit,sirun},
        {"Galaxian",galaxianinit,galaxianrun},
        {"War Of The Bugs",warofbuginit,galaxianrun},
        {"Pac-Man (bootleg on Galaxian)",pacmanblinit,galaxianrun},
        {"Anteater",anteaterinit,anteaterrun},
        {"Amidar",amidarinit,amidarrun},
        {"Turtles",turtlesinit,amidarrun},
        {"Bombjack",bombjackinit,bombjackrun},
        {"Mr. Do!",mrdoinit,mrdorun},
        {"Nibbler",nibblerinit,nibblerrun},
        {"Super Cobra",scobrainit,anteaterrun},
        {"Mr. Do's Castle",docastleinit,dorunrunrun},
        {"Do! Run Run",dorunruninit,dorunrunrun},
        {"",NULL,NULL}
};

int choosegame()
{
        int c=0,temp;
        while (1)
        {
                if (games[c].run)
                {
                        if (c<10)
                           printf("%i.%s\n",c,games[c].name);
                        else
                           printf("%c.%s\n",c-10+65,games[c].name);
                }
                else
                   break;
                c++;
        }
        temp=getch()-'0';
        if (temp>9)
        {
                temp-=7;
                if (temp>26)
                   temp-=32;
        }
        return temp;
}

int main()
{
        game=choosegame();
        allegro_init();
        get_palette(yaamepal);
        install_keyboard();
        install_timer();
        chdir("roms");
        games[game].init();
        chdir("..");
        printf("Press a key to start");
        readkey();
        if (set_gfx_mode(GFX_VESA2L,400,300,0,0))
           set_gfx_mode(GFX_MODEX,400,300,0,0);
        set_palette(yaamepal);
        inityaame();
        games[game].run();
        return 0;
}
